var custombutton={

  selectImage : function(textboxid){
    var fp = Components.classes["@mozilla.org/filepicker;1"]
          .createInstance(Components.interfaces.nsIFilePicker);
    fp.init(window, 'Customizable Toolbar Buttons Image', Components.interfaces.nsIFilePicker.modeOpen);
    fp.appendFilters(Components.interfaces.nsIFilePicker.filterImages);
    fp.appendFilters(Components.interfaces.nsIFilePicker.filterAll);

    var ret = fp.show();
    if (ret == Components.interfaces.nsIFilePicker.returnOK) {
      var folderField = document.getElementById(textboxid);
      folderField.value = fp.fileURL.spec;
    }
  },

  settings : function(){
    window.open("chrome://custombutton/content/settings.xul","_custombutton_settings","chrome,resizable");
  },
  init : function(){
	setTimeout(custombutton.delayedInit,100);
  },
  delayedInit : function(){
    custombuttonObjectService.updateWindow();
  }

};

var custombuttonDNDObserver =
{
  getSupportedFlavours : function ()
  {
    var flavourSet = new FlavourSet();
    flavourSet.appendFlavour("text/x-custombutton-uri");
    flavourSet.appendFlavour("text/x-moz-url");
    flavourSet.appendFlavour("text/unicode");
    return flavourSet;
  },

  onDragOver: function (evt,flavour,session){},

  onDrop: function (event,dropdata,session){
    try{
      switch(dropdata.flavour.contentType)
      {
      case "text/x-custombutton-uri":
          var FromURI  =dropdata.data;
          var ToURI  =event.target.parentNode.id;
          custombuttonObjectService.move(FromURI,ToURI);
        break;
      case "text/x-moz-url":
          var text=dropdata.data;
          text=text.split("\n");
          var url=text[0];
          var name=text[1];
          var button = new CustomButtonObject("urn:custombutton:"+url);
          button.properties["label"]=name;
          button.properties["tooltiptext"]=url;
          button.properties["oncommand"]="loadURI(\""+url+"\",null)";
          button.append();
        break;
      case "text/unicode":
          var text=dropdata.data;
          var button = new CustomButtonObject();
          button.properties["label"]=text;
          button.properties["tooltiptext"]=text;
          button.properties["oncommand"]="loadURI(\""+text+"\",null)";
          button.append();
        break;
      default:
        break;
      }
    }catch(e){alert(e);}
  },

  onDragStart: function (event,transferData,action){
    var text=event.target.parentNode.id;
    transferData.data=new TransferData();
    transferData.data.addDataForFlavour("text/x-custombutton-uri",text);
  }
};

window.addEventListener("load",custombutton.init,false);
